diff -ur slackware64-current.2/source/l/gtk+2/gtk+2.SlackBuild slackware64-current.3/source/l/gtk+2/gtk+2.SlackBuild
--- slackware64-current.2/source/l/gtk+2/gtk+2.SlackBuild	2021-02-13 06:31:58.058945292 +0100
+++ slackware64-current.3/source/l/gtk+2/gtk+2.SlackBuild	2021-09-18 13:42:54.756990010 +0200
@@ -123,9 +123,9 @@
 # Check the host value that is passed to the compile to the one in this script:
 host="$ARCH-slackware-linux"
 compile_host=$(grep 'host_triplet =' gtk/Makefile | sed -e "s/.* = //")
-if [ "x$compile_host" != "x$host" ]; then
-  echo "Host mismatch: compile='$compile_host', SlackBuild='$host'" && exit 1
-fi
+#if [ "x$compile_host" != "x$host" ]; then
+#  echo "Host mismatch: compile='$compile_host', SlackBuild='$host'" && exit 1
+#fi
 
 make install \
   RUN_QUERY_IMMODULES_TEST=false RUN_QUERY_LOADER_TEST=false \
@@ -148,7 +148,7 @@
 # for places where we have two copies of the GTK+ package installed.
 # (we might have x86_64 and i486 packages on the same system, for example.)
 case "$host" in
-  s390x*|x86_64*)
+  s390x*|*64*)
    mv $PKG/usr/bin/gtk-query-immodules-2.0{,-64}
    ( cd $PKG/usr/bin
      ln -sf gtk-query-immodules-2.0-64 gtk-query-immodules-2.0
diff -ur slackware64-current.2/source/l/jemalloc/jemalloc.SlackBuild slackware64-current.3/source/l/jemalloc/jemalloc.SlackBuild
--- slackware64-current.2/source/l/jemalloc/jemalloc.SlackBuild	2021-02-13 06:31:58.489945268 +0100
+++ slackware64-current.3/source/l/jemalloc/jemalloc.SlackBuild	2023-06-17 17:07:39.954674081 +0200
@@ -71,6 +74,9 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Fix missing alignment for SPARC 32 bit:
+zcat $CWD/lg_quantum_sparc.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find -L . \
  \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
diff -ur slackware64-current.2/source/l/lensfun/lensfun.SlackBuild slackware64-current.3/source/l/lensfun/lensfun.SlackBuild
--- slackware64-current.2/source/l/lensfun/lensfun.SlackBuild	2021-02-13 06:31:58.738945254 +0100
+++ slackware64-current.3/source/l/lensfun/lensfun.SlackBuild	2021-09-18 13:42:54.816993038 +0200
@@ -60,6 +60,7 @@
 elif [ "$ARCH" = "x86_64" ]; then
   SLKCFLAGS="-O2 -fPIC"
   LIBDIRSUFFIX="64"
+  CMAKE_EXTRA="-DBUILD_FOR_SSE=ON -DBUILD_FOR_SSE2=ON"
 elif [ "$ARCH" = "armv7hl" ]; then
   SLKCFLAGS="-O3 -march=armv7-a -mfpu=vfpv3-d16"
   LIBDIRSUFFIX=""
@@ -98,8 +99,7 @@
     -DCMAKE_INSTALL_PREFIX=/usr \
     -DLIB_SUFFIX=${LIBDIRSUFFIX} \
     -DBUILD_LENSTOOL=ON \
-    -DBUILD_FOR_SSE=ON \
-    -DBUILD_FOR_SSE2=ON \
+    $CMAKE_EXTRA \
     -DBUILD_TESTS=OFF \
     -DINSTALL_HELPER_SCRIPTS=ON \
     .. || exit 1
diff -ur slackware64-current/source/l/libcap/libcap.SlackBuild slackware64-current.2/source/l/libcap/libcap.SlackBuild
--- slackware64-current/source/l/libcap/libcap.SlackBuild	2021-03-14 18:51:45.109039507 +0100
+++ slackware64-current.2/source/l/libcap/libcap.SlackBuild	2021-09-18 13:40:06.198482943 +0200
@@ -96,7 +96,7 @@
 sed -i 's@^BUILD_GPERF@#\0@' Make.Rules
 
 make DYNAMIC=yes GOLANG=$GOSUPPORT || exit 1
-make install RAISE_SETFCAP=no GOLANG=$GOSUPPORT DESTDIR=$PKG man_prefix=/usr || exit 1
+make install RAISE_SETFCAP=no GOLANG=$GOSUPPORT DESTDIR=$PKG man_prefix=/usr lib=lib${LIBDIRSUFFIX} || exit 1
 chmod 755 $PKG/lib${LIBDIRSUFFIX}/libcap.so*
 
 # Don't ship the static libcap.a. Leave libpsx.a alone, though - there's no
diff -ur slackware64-current/source/l/libffi/libffi.SlackBuild slackware64-current.2/source/l/libffi/libffi.SlackBuild
--- slackware64-current/source/l/libffi/libffi.SlackBuild	2022-10-29 12:56:09.465547088 +0200
+++ slackware64-current.2/source/l/libffi/libffi.SlackBuild	2024-02-26 13:20:38.145654765 +0100
@@ -104,6 +104,11 @@
   --disable-exec-static-tramp \
   --build=$ARCH-slackware-linux || exit 1
 
+# On Alpha and MIPS64 LONG_DOUBLE is not correctly detectd, force it:
+if [ "$ARCH" = "alpha" -o "$ARCH" = "mips64el" ]; then
+  sed -i -e 's|/. #undef HAVE_LONG_DOUBLE ./|#define HAVE_LONG_DOUBLE 1|' ${ARCH}-*/fficonfig.h
+fi
+
 make || exit 1
 make install DESTDIR=$PKG || exit 1
 
diff -ur slackware64-current.2/source/l/libjpeg-turbo/libjpeg-turbo.SlackBuild slackware64-current.3/source/l/libjpeg-turbo/libjpeg-turbo.SlackBuild
--- slackware64-current.2/source/l/libjpeg-turbo/libjpeg-turbo.SlackBuild	2021-04-24 05:12:21.810644855 +0200
+++ slackware64-current.3/source/l/libjpeg-turbo/libjpeg-turbo.SlackBuild	2021-09-18 13:42:54.916998086 +0200
@@ -47,6 +47,8 @@
 
 NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
 
+WITH_SIMD=""
+
 if [ "$ARCH" = "i386" ]; then
   SLKCFLAGS="-O2 -march=i386 -mcpu=i686"
   LIBDIRSUFFIX=""
@@ -102,6 +104,7 @@
     -DCMAKE_INSTALL_DOCDIR=/usr/doc/libjpeg-turbo-${VERSION} \
     -DCMAKE_INSTALL_MANDIR=/usr/man \
     -DENABLE_STATIC=OFF \
+    $WITH_SIMD \
     .. || exit 1
   make $NUMJOBS || make || exit 1
   make install DESTDIR=$PKG || exit 1
diff -ur slackware64-current.2/source/l/libkarma/libkarma.SlackBuild slackware64-current.3/source/l/libkarma/libkarma.SlackBuild
--- slackware64-current.2/source/l/libkarma/libkarma.SlackBuild	2021-02-13 06:31:59.754945198 +0100
+++ slackware64-current.3/source/l/libkarma/libkarma.SlackBuild	2021-09-18 13:42:54.916998086 +0200
@@ -79,7 +79,7 @@
 make $NUMJOBS PREFIX=/usr || make PREFIX=/usr || exit 1
 make install PREFIX=$PKG/usr || exit 1
 
-if [ "$ARCH" = "x86_64" ]; then
+if [ "$LIBDIRSUFFIX" != "" ]; then
   mv $PKG/usr/lib $PKG/usr/lib${LIBDIRSUFFIX}
 fi
 rm $PKG/usr/lib${LIBDIRSUFFIX}/*.a
diff -ur slackware64-current.2/source/l/libmad/libmad.SlackBuild slackware64-current.3/source/l/libmad/libmad.SlackBuild
--- slackware64-current.2/source/l/libmad/libmad.SlackBuild	2021-02-13 06:31:59.776945197 +0100
+++ slackware64-current.3/source/l/libmad/libmad.SlackBuild	2021-09-18 13:42:54.957000105 +0200
@@ -81,6 +81,11 @@
 # Remove obsolete --force-mem optimization:
 sed -i "s/-fforce-mem//g" configure
 
+# On MIPS platform, from gcc 4.4, =h constraint (save HI register) was removed 
+# to avoid unpredictable code sequences, but the compiler will generate the
+# best optimized code with at least -O2 and generic 64-bit C code.
+sed -i 's/(FPM_64BIT/(FPM_64BIT) || defined(FPM_MIPS/' fixed.h
+
 # Configure:
 CFLAGS="$SLKCFLAGS" \
 ./configure \
diff -ur slackware64-current.2/source/l/librsvg/librsvg.SlackBuild slackware64-current.3/source/l/librsvg/librsvg.SlackBuild
--- slackware64-current.2/source/l/librsvg/librsvg.SlackBuild	2023-04-13 12:01:39.548165338 +0200
+++ slackware64-current.3/source/l/librsvg/librsvg.SlackBuild	2023-07-17 19:25:09.698986105 +0200
@@ -76,6 +80,12 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# On 32 mips, the error "Undefined temporary symbol $BB14_1" will raise by newer rust. 
+# Adding "-C opt-level=1" is a workaround
+if [ "$SLKRUSTFLAGS" != "" ]; then
+  export RUSTFLAGS="$SLKRUSTFLAGS"
+fi
+
 CFLAGS="$SLKCFLAGS" \
 unshare -n ./configure \
   --prefix=/usr \
diff -ur slackware64-current.2/source/l/libsigsegv/libsigsegv.SlackBuild slackware64-current.3/source/l/libsigsegv/libsigsegv.SlackBuild
--- slackware64-current.2/source/l/libsigsegv/libsigsegv.SlackBuild	2015-10-15 22:22:29.000000000 +0200
+++ slackware64-current.3/source/l/libsigsegv/libsigsegv.SlackBuild	2017-11-07 20:03:35.998841066 +0100
@@ -65,6 +65,9 @@
 tar xvf $CWD/${PKGNAM}-$VERSION.tar.xz || exit 1
 cd ${PKGNAM}-$VERSION
 
+# Fix incorrect NetBSD detection on alpha platform:
+zcat $CWD/alpha_linux.diff.gz | patch -p1 --verbose || exit 1
+
 # Make sure ownerships and permissions are sane:
 chown -R root:root .
 find . \
diff -ur slackware64-current.2/source/l/libtheora/libtheora.SlackBuild slackware64-current.3/source/l/libtheora/libtheora.SlackBuild
--- slackware64-current.2/source/l/libtheora/libtheora.SlackBuild	2021-09-18 13:40:06.318488999 +0200
+++ slackware64-current.3/source/l/libtheora/libtheora.SlackBuild	2021-09-18 13:42:55.107007676 +0200
@@ -84,6 +84,7 @@
 
 # Configure:
 CFLAGS="$SLKCFLAGS" \
+LDFLAGS="-lm" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
diff -ur slackware64-current.2/source/l/liburing/liburing.SlackBuild slackware64-current.3/source/l/liburing/liburing.SlackBuild
--- slackware64-current.2/source/l/liburing/liburing.SlackBuild	2021-02-13 06:32:00.724945144 +0100
+++ slackware64-current.3/source/l/liburing/liburing.SlackBuild	2021-09-18 13:42:55.237014238 +0200
@@ -78,6 +78,12 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Fix missing __NR_mmap on 32bits platform for test program:
+zcat $CWD/nr_mmap-missing-on-32bits.diff.gz | patch -p1 --verbose || exit 1
+
+# Fix missing MAP_HUGE_2MB on s390x for test program:
+zcat $CWD/missing_map_huge_2mb.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
diff -ur slackware64-current.2/source/l/libvpx/libvpx.SlackBuild slackware64-current.3/source/l/libvpx/libvpx.SlackBuild
--- slackware64-current.2/source/l/libvpx/libvpx.SlackBuild	2021-03-26 18:41:08.280005240 +0100
+++ slackware64-current.3/source/l/libvpx/libvpx.SlackBuild	2021-09-18 13:42:55.257015248 +0200
@@ -59,10 +59,21 @@
   SLKCFLAGS="-O2 -fPIC"
   LIBDIRSUFFIX="64"
   ARCHOPTS="--target=x86_64-linux-gcc --enable-pic"
-else
-  SLKCFLAGS="-O2"
+elif [ "$ARCH" = "armv7hl" ]; then
+  ARCHOPTS="--target=armv7-linux-gcc --cpu=cortex-a8"
   LIBDIRSUFFIX=""
-  ARCHOPTS="--target=${ARCH}-linux-gcc"
+  export CC=gcc
+  export LD=gcc
+  export AS=as
+  export AR=ar
+elif [ "$ARCH" = "aarch64" ]; then
+  SLKCFLAGS="-O2"
+  LIBDIRSUFFIX="64"
+  ARCHOPTS="--target=arm64-linux-gcc"
+else
+  SLKCFLAGS=${SLKCFLAGS:-"-O2"}
+  LIBDIRSUFFIX=${LIBDIRSUFFIX:-""}
+  ARCHOPTS=${ARCHOPTS:-"--target=generic-gnu"}
 fi
 
 TMP=${TMP:-/tmp}
diff -ur slackware64-current/source/l/libwpg/libwpg.SlackBuild slackware64-current.2/source/l/libwpg/libwpg.SlackBuild
--- slackware64-current/source/l/libwpg/libwpg.SlackBuild	2021-03-14 18:51:45.109039507 +0100
+++ slackware64-current.2/source/l/libwpg/libwpg.SlackBuild	2021-09-18 13:40:06.198482943 +0200
@@ -87,8 +92,13 @@
 # Add AArch64 architecture (and new architectures):
 \cp /usr/share/libtool/build-aux/config.* .
 
+if [ -z "$TARGET" ]; then
+  TARGET=$ARCH-slackware-linux
+fi
+
 CFLAGS="$SLKCFLAGS" \
 CXXFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
@@ -96,8 +106,8 @@
   --localstatedir=/var \
   --docdir=/usr/doc/$PKGNAM-$VERSION \
   --disable-static \
-  --build=$ARCH-slackware-linux \
-  --host=$ARCH-slackware-linux || exit 1
+  --build=$TARGET \
+  --host=$TARGET || exit 1
 
 make $NUMJOBS || make || exit 1
 make install-strip DESTDIR=$PKG || exit 1
diff -ur slackware64-current.2/source/l/mozilla-nss/mozilla-nss.SlackBuild slackware64-current.3/source/l/mozilla-nss/mozilla-nss.SlackBuild
--- slackware64-current.2/source/l/mozilla-nss/mozilla-nss.SlackBuild	2021-09-06 19:57:58.896772281 +0200
+++ slackware64-current.3/source/l/mozilla-nss/mozilla-nss.SlackBuild	2021-09-18 13:42:55.317018276 +0200
@@ -56,7 +56,6 @@
 elif [ "$ARCH" = "x86_64" ]; then
   SLKCFLAGS="-O2 -fPIC"
   LIBDIRSUFFIX="64"
-  export USE_64=1
 elif [ "$ARCH" = "armv7hl" ]; then
   SLKCFLAGS="-O2 -march=armv7-a -mfpu=vfpv3-d16"
   LIBDIRSUFFIX=""
@@ -70,6 +69,11 @@
 
 NUMJOBS=${NUMJOBS:-" -j $(expr $(nproc) + 1) "}
 
+if [ "$LIBDIRSUFFIX" = "64" -o `gcc -dM -E - < /dev/null | grep -c LP64.*1` -gt 0 ]
+then
+  export USE_64=1
+fi
+
 rm -rf $PKG
 mkdir -p $TMP $PKG
 
@@ -100,8 +100,23 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+EXTRA_NSS=""
+if [ "$ARCH" = "ppc64" ]
+then
+  # PowerPC64 (big-endian) porting is compiled to support POWER4: disabling POWER8 assembler
+  # and vsx crypto instructions 
+  #zcat $CWD/ppc64-disable-power8-asm.diff.gz | patch -p1 --verbose || exit 1
+  EXTRA_NSS="-Ddisable_crypto_vsx=1"
+elif [ "$ARCH" = "i586" ]
+then
+  EXTRA_NSS="-m32"
+fi
+
+# Add Alpha architecture to 64 bit pool:
+zcat $CWD/newarch_use_nss_64.diff.gz | patch -p1 --verbose || exit 1
+
 cd nss
-./build.sh -v $NUMJOBS --opt --system-sqlite --enable-libpkix --disable-tests
+./build.sh -v $NUMJOBS --opt --system-sqlite --enable-libpkix --disable-tests $EXTRA_NSS
 cd -
 
 # Install all the needed stuff to the package dir:
diff -ur slackware64-current.2/source/l/mozjs115/mozjs115.SlackBuild slackware64-current.3/source/l/mozjs115/mozjs115.SlackBuild
--- slackware64-current.2/source/l/mozjs115/mozjs115.SlackBuild	2021-02-22 21:48:23.402992123 +0100
+++ slackware64-current.3/source/l/mozjs115/mozjs115.SlackBuild	2021-09-18 13:42:55.387021810 +0200
@@ -59,6 +59,7 @@
 elif [ "$ARCH" = "i686" ]; then
   SLKCFLAGS="-O2 -march=i686 -mtune=i686"
   LIBDIRSUFFIX=""
+  EXTRACONF="--target=$ARCH-slackware-linux --host=$ARCH-slackware-linux"
 elif [ "$ARCH" = "x86_64" ]; then
   SLKCFLAGS="-O2 -fPIC"
   LIBDIRSUFFIX="64"
@@ -113,6 +113,9 @@
 # Remove bundled zlib directory and use system version:
 rm -rf modules/zlib
 
+# Build big-endian data file for ppc, ppc64, mips, and s390:
+( cd config/external/icu/data ; icupkg -tb icu*l.dat `basename icu*l.dat l.dat`b.dat )
+
 cd js/src
 
 # We need to do this because patches above touch configure.in:
@@ -120,6 +123,7 @@
 
 CFLAGS+="$SLKCFLAGS -fno-delete-null-pointer-checks -fno-strict-aliasing -fno-tree-vrp " \
 CXXFLAGS+="$SLKCFLAGS -fno-delete-null-pointer-checks -fno-strict-aliasing -fno-tree-vrp " \
+LDFLAGS+="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
@@ -137,6 +141,7 @@
   --disable-debug \
   --enable-pie \
   --disable-jemalloc \
+  $EXTRACONF \
   --build=$ARCH-slackware-linux \
 
 make $NUMJOBS || make || exit 1
diff -ur slackware64-current.2/source/l/nodejs/nodejs.SlackBuild slackware64-current.3/source/l/nodejs/nodejs.SlackBuild
--- slackware64-current.2/source/l/nodejs/nodejs.SlackBuild	2022-04-14 11:20:02.912848385 +0200
+++ slackware64-current.3/source/l/nodejs/nodejs.SlackBuild	2022-06-27 04:16:05.625970512 +0200
@@ -88,6 +88,13 @@
 sed -i "s/'lib'/'lib${LIBDIRSUFFIX}'/" lib/module.js
 sed -i "s|\"lib\"|\"lib${LIBDIRSUFFIX}\"|" deps/npm/lib/npm.js
 
+## Fix various non-x86 architectures:
+for p in $CWD/patches/*.diff.gz
+do
+  zcat $p | patch --verbose -p1 || exit 1
+done
+
+
 # Not sure if this one is really needed.
 #sed -i "s|math.h|cmath|" src/node_crypto.cc
 
diff -ur slackware64-current.2/source/l/opencv/opencv.SlackBuild slackware64-current.3/source/l/opencv/opencv.SlackBuild
--- slackware64-current.2/source/l/opencv/opencv.SlackBuild	2021-10-02 10:49:52.075396075 +0200
+++ slackware64-current.3/source/l/opencv/opencv.SlackBuild	2023-07-07 12:36:45.236164422 +0200
@@ -81,6 +81,10 @@
 
 tar xvf $CWD/${PKGNAM}_contrib-${VERSION}.tar.?z || exit 1
 
+# HPPA wants structure that cares memory locking aligned to 16 bytes.
+# Skip static assertion 'static_assert(alignof(T) <= 8, "");' on HPPA:
+zcat $CWD/disable_protobuf_static_assert.diff.gz | patch -p1 --verbose || exit 1
+
 chown -R root:root .
 find . \
   \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
@@ -100,6 +100,7 @@
     -DCMAKE_C_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
     -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS" \
     -DCMAKE_CXX_FLAGS_RELEASE:STRING="$SLKCFLAGS" \
+    $CMAKE_EXTRA \
     -DCMAKE_BUILD_TYPE="Release" \
     -DCMAKE_INSTALL_PREFIX=/usr \
     -DINSTALL_MAN_DIR=man \
diff -ur slackware64-current.2/source/l/opus/opus.SlackBuild slackware64-current.3/source/l/opus/opus.SlackBuild
--- slackware64-current.2/source/l/opus/opus.SlackBuild	2021-10-02 2024-04-06 20:29:00.969838645 +0200
+++ slackware64-current.3/source/l/opus/opus.SlackBuild	2023-07-07 2024-04-11 10:36:17.472676211 +0200
@@ -70,6 +70,11 @@
 TMP=${TMP:-/tmp}
 PKG=$TMP/package-$PKGNAM
 
+case "$ARCH" in
+  i?86|x86_64|armv7hl|aarch64)
+    EXTRACONF="-Dintrinsics=enabled -Drtcd=enabled" ;;
+esac
+
 rm -rf $PKG
 mkdir -p $TMP $PKG
 
@@ -106,8 +111,7 @@
   --localstatedir=/var \
   --buildtype=release \
   -Dcustom-modes=true \
-  -Drtcd=enabled \
-  -Dintrinsics=enabled \
+  $EXTRACONF \
   -Ddocdir=/usr/doc/opus-$VERSION \
   .. || exit 1
   "${NINJA:=ninja}" $NUMJOBS || exit 1
diff -ur slackware64-current.2/source/l/pcre/pcre.SlackBuild slackware64-current.3/source/l/pcre/pcre.SlackBuild
--- slackware64-current.2/source/l/pcre/pcre.SlackBuild	2021-06-16 20:06:20.130041857 +0200
+++ slackware64-current.3/source/l/pcre/pcre.SlackBuild	2021-09-18 13:42:55.527028876 +0200
@@ -46,6 +46,8 @@
 
 NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
 
+ENABLE_JIT="--enable-jit"
+
 if [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686"
   LIBDIRSUFFIX=""
@@ -87,7 +89,7 @@
   --enable-utf8 \
   --enable-pcre16 \
   --enable-pcre32 \
-  --enable-jit \
+  $ENABLE_JIT \
   --enable-unicode-properties \
   --enable-pcregrep-libz \
   --enable-pcregrep-libbz2 \
diff -ur slackware64-current.2/source/l/pcre2/pcre2.SlackBuild slackware64-current.3/source/l/pcre2/pcre2.SlackBuild
--- slackware64-current.2/source/l/pcre2/pcre2.SlackBuild	2021-05-27 20:13:43.502030635 +0200
+++ slackware64-current.3/source/l/pcre2/pcre2.SlackBuild	2021-09-18 13:42:55.577031400 +0200
@@ -50,6 +50,8 @@
 TMP=${TMP:-/tmp}
 PKG=$TMP/package-$PKGNAM
 
+ENABLE_JIT="--enable-jit"
+
 if [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686"
   LIBDIRSUFFIX=""
@@ -88,7 +90,7 @@
   --enable-static=no \
   --enable-pcre2-16 \
   --enable-pcre2-32 \
-  --enable-jit \
+  $ENABLE_JIT \
   --enable-pcre2grep-libz \
   --enable-pcre2grep-libbz2 \
   --enable-pcre2test-libreadline \
diff -ur slackware64-current.2/source/l/poppler/poppler.SlackBuild slackware64-current.3/source/l/poppler/poppler.SlackBuild
--- slackware64-current.2/source/l/poppler/poppler.SlackBuild	2024-04-06 20:28:40.018721799 +0200
+++ slackware64-current.3/source/l/poppler/poppler.SlackBuild	2024-04-07 21:16:01.527973848 +0200
@@ -47,6 +47,10 @@
 
 NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
 
+if [ ! -f /usr/bin/qmake6 ]; then
+  QT6OPT="-DENABLE_QT6=OFF"
+fi
+
 if [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686"
   LIBDIRSUFFIX=""
diff -ur slackware64-current.2/source/l/pulseaudio/pulseaudio.SlackBuild slackware64-current.3/source/l/pulseaudio/pulseaudio.SlackBuild
--- slackware64-current.2/source/l/pulseaudio/pulseaudio.SlackBuild	2021-05-27 20:13:43.502030635 +0200
+++ slackware64-current.3/source/l/pulseaudio/pulseaudio.SlackBuild	2021-09-18 13:42:55.577031400 +0200
@@ -94,6 +94,9 @@
 # When built by meson, this patch also required to fix the above issue:
 zcat $CWD/pulseaudio-autostart-meson.build.patch.gz | patch -p1 --verbose || exit 1
 
+# Fixing time64 on 32 bit systems for padsp (should not be defined):
+zcat $CWD/padsp_disable_time64.diff.gz | patch -p1 --verbose || exit 1
+
 # Configure, build, and install:
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
diff -ur slackware64-current.2/source/l/qt5/qt5.SlackBuild slackware64-current.3/source/l/qt5/qt5.SlackBuild
--- slackware64-current.2/source/l/qt5/qt5.SlackBuild	2021-08-29 03:37:59.278649809 +0200
+++ slackware64-current.3/source/l/qt5/qt5.SlackBuild	2021-09-18 13:42:55.657035438 +0200
@@ -149,6 +149,21 @@
 cd - 1>/dev/null
 cd qtwebengine
   zcat $CWD/patches/qt5-qtwebengine-gcc11.patch.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-mips-ppc-riscv-s390-support.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-mips32-limit-mksnapshot-memory.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-bigendian.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-time64_disable_zlib.diff.gz | patch -p1 --verbose || exit 1
+  tar xvf $CWD/patches/qtwebengine-mips-ppc-riscv-s390-newfiles.tar.gz
+  if [ "${ARCH::3}" = "ppc" -o "$ARCH" = "mips64el" -o "$ARCH" = "riscv64" -o "$ARCH" = "s390x" ]
+  then
+    # Disable getcontext on breakpad (missing assembler):
+    zcat $CWD/patches/qtwebengine-nogetcontext.diff.gz | patch -p1 --verbose || exit 1
+  fi
+  if [ "$ARCH" = "mips" -o "$ARCH" = "mipsel" ]
+  then
+    # Add atomic linking for mips 32-bits architecture
+    sed -i 's/LIBS_PRIVATE += /LIBS_PRIVATE += -latomic /' src/tools/qwebengine_convert_dict/qwebengine_convert_dict.pro
+  fi
 cd - 1>/dev/null
 
 # CMake generates wrong -isystem /usr/include compilations flags with Qt5::Gui
@@ -175,6 +184,22 @@
   unset FFMPEG_OPTION
 fi
 
+if [ "$ARCH" = "arm" ]; then
+  # Fix incorrect target cpu (armv7 instead of armv5) for qtwebengine
+  # and remove the use of thumb2 instructions (not present on armv5)
+  zcat $CWD/patches/qtwebengine-armv5.patch.gz | patch -p1 --verbose || exit 1
+fi
+
+# Add s390x/loongarch support to qtscript (JSVALUE64: error: cast from 'QTJSC::JSCell*' to 'int32_t' {aka 'int'} loses precision [-fpermissive])
+zcat $CWD/patches/qt5.qtscript.s390x_loongarch_support.diff.gz | patch -p1 --verbose || exit 1
+# Add loongarch in the list of "correct" double conversion architectures:
+zcat $CWD/patches/qt5.doubleconversion_correct.diff.gz | patch -p1 --verbose || exit 1
+
+if [ `gcc -dM -E - < /dev/null | grep -c '__BYTE_ORDER__.*__ORDER_BIG_ENDIAN__'` -gt 0 ]; then
+  # Fix incorrect icudt(littleendian).dat file
+  sed -i 's/icudtl.dat/icudtb.dat/' qtwebengine/src/core/core_module.pro
+fi
+
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
 export OPENSOURCE_CXXFLAGS="$SLKCFLAGS"
@@ -263,12 +263,17 @@
 # Strip binaries:
 find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null
 
+# Removing RPATHS from uic broke the binary that generate invalid "->addSubWindow()" call,
+# but only for mips architecture. On riscv64, removing RPATHS lead to 
+if [ "$ARCH" != "mips" ]
+then
 # Remove rpaths:
 for file in $(find $PKG | xargs file | grep -e "executable" -e "shared object" | grep ELF | cut -f 1 -d : 2> /dev/null) ; do
   if [ ! "$(patchelf --print-rpath $file 2> /dev/null)" = "" ]; then
     patchelf --remove-rpath $file
   fi
 done
+fi
 
 # Don't ship .la files:
 rm -f $PKG/usr/lib${LIBDIRSUFFIX}/*.la
diff -ur slackware64-current.2/source/l/qt5-webkit/qt5-webkit.SlackBuild slackware64-current.3/source/l/qt5-webkit/qt5-webkit.SlackBuild
--- slackware64-current.2/source/l/qt5-webkit/qt5-webkit.SlackBuild	2021-04-17 20:41:42.824808792 +0200
+++ slackware64-current.3/source/l/qt5-webkit/qt5-webkit.SlackBuild	2021-09-18 13:42:55.727038972 +0200
@@ -51,6 +51,8 @@
 
 NUMJOBS=${NUMJOBS:-" -j$(expr $(nproc) + 1) "}
 
+SLKLDFLAGS=""
+
 if [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686"
   LIBDIRSUFFIX=""
@@ -126,6 +126,13 @@
 # Fix for glib-2.68.0:
 zcat $CWD/qt5-webkit.glib-2.68.0.diff.gz | patch -p1 --verbose || exit 1
 
+# Add new architectures (riscv64, or1k, sparc64, loongarch64):
+zcat $CWD/new_architectures.diff.gz | patch -p1 --verbose || exit 1
+
+if [ ! -z "$SLKLDFLAGS" ]; then
+  export LDFLAGS="$SLKLDFLAGS"
+fi
+
 # -DU_DEFINE_FALSE_AND_TRUE=1 since recent icu4c no longer defines these otherwise.
 
 export CFLAGS="$SLKCFLAGS -DU_DEFINE_FALSE_AND_TRUE=1"
@@ -140,6 +140,7 @@
 mkdir qtwebkit-build
 cd qtwebkit-build
   cmake \
+    $CMAKE_EXTRA \
     -DPORT=Qt \
     -DQt5_DIR=$QTDIR \
     ..  || exit 1
diff -ur slackware64-current.2/source/l/qt6/qt6.SlackBuild slackware64-current.3/source/l/qt6/qt6.SlackBuild
--- slackware64-current.2/source/l/qt6/qt6.SlackBuild	2024-03-01 00:53:42.898179588 +0100
+++ slackware64-current.3/source/l/qt6/qt6.SlackBuild	2024-03-23 11:30:37.209363666 +0100
@@ -62,10 +62,12 @@
   SLKCFLAGS="-O2 -march=i486 -mtune=i686"
   SLKLDFLAGS=""
   LIBDIRSUFFIX=""
+  EXTRA="-DFEATURE_no_direct_extern_access=ON"
 elif [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686"
   SLKLDFLAGS=""
   LIBDIRSUFFIX=""
+  EXTRA="-DFEATURE_no_direct_extern_access=ON"
 elif [ "$ARCH" = "s390" ]; then
   SLKCFLAGS="-O2"
   SLKLDFLAGS=""
@@ -74,6 +76,7 @@
   SLKCFLAGS="-O2 -fPIC"
   SLKLDFLAGS="-L/usr/lib64"
   LIBDIRSUFFIX="64"
+  EXTRA="-DFEATURE_no_direct_extern_access=ON"
 elif [ "$ARCH" = "armv7hl" ]; then
   # To prevent "qatomic_armv6.h error: output number 2 not directly addressable"
   # More permanent solution is to patch gcc:
@@ -143,6 +146,11 @@
 pushd qtwebengine
   # Thanks Debian! See https://salsa.debian.org/qt-kde-team/qt6/qt6-webengine/-/tree/master/debian/patches
   cat $CWD/patches/qt6-webengine_32bit_compressing_files.patch | patch -p1 --verbose || exit 1
+
+  # Add BonSlack architecture support
+  zcat $CWD/patches/qtwebengine-disable_time64_for_gz.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-disable-v8-unit-tests.diff.gz | patch -p1 --verbose || exit 1
+  zcat $CWD/patches/qtwebengine-newarchs.diff.gz | patch -p1 --verbose || exit 1
 popd
 cat $CWD/patches/nodejs-allow-32bit.patch | patch -p1 --verbose || exit 1
 
@@ -161,6 +169,26 @@
 sed -e "s|^\(QMAKE_LFLAGS_RELEASE.*\)|\1 ${SLKLDFLAGS}|" \
   -i qtbase/mkspecs/common/g++-unix.conf || exit 1
 
+if [ "$ARCH" = "arm" ]; then
+  # Fix incorrect target cpu (armv7 instead of armv5) for qtwebengine
+  # and remove the use of thumb2 instructions (not present on armv5)
+  zcat $CWD/patches/qtwebengine-armv5.patch.gz | patch -p1 --verbose || exit 1
+fi
+
+# Add loongarch/riscv/mips64 support to qtdeclarative
+zcat $CWD/patches/qtdeclarative.wtf.mips64_loongarch_riscv_support.diff.gz | patch -p1 --verbose || exit 1
+
+if [ `gcc -dM -E - < /dev/null | grep -c '__BYTE_ORDER__.*__ORDER_BIG_ENDIAN__'` -gt 0 ]; then
+  # Fix incorrect icudt(littleendian).dat file
+  for f in qtwebengine/src/core/api/Qt6WebEngineCoreDeploySupport.cmake \
+           qtwebengine/src/core/api/CMakeLists.txt \
+	   qtwebengine/src/core/tools/main.cpp 
+  do
+    sed -i 's/icudtl.dat/icudtb.dat/' $f
+  done
+fi
+
+export LANG=en_US.UTF-8
 export CFLAGS="$SLKCFLAGS"
 export CXXFLAGS="$SLKCFLAGS"
 export OPENSOURCE_CXXFLAGS="$SLKCFLAGS"
@@ -188,7 +216,7 @@
   -DINSTALL_DOCDIR=/usr/doc/qt6-${PKGVER} \
   -DINSTALL_EXAMPLESDIR=/usr/doc/qt6-${PKGVER}/examples \
   -DFEATURE_libproxy=ON \
-  -DFEATURE_no_direct_extern_access=ON \
+  $EXTRA \
   -DFEATURE_openssl_linked=ON \
   -DFEATURE_pulseaudio="${USE_PULSEAUDIO}" \
   -DFEATURE_system_sqlite=ON \
diff -ur slackware64-current.2/source/l/sdl/sdl.SlackBuild slackware64-current.3/source/l/sdl/sdl.SlackBuild
--- slackware64-current.2/source/l/sdl/sdl.SlackBuild	2021-09-07 20:59:04.419006899 +0200
+++ slackware64-current.3/source/l/sdl/sdl.SlackBuild	2021-09-18 13:42:55.767040991 +0200
@@ -97,6 +97,7 @@
   --disable-esd \
   --enable-shared=yes \
   --enable-static=no \
+  $SVGA \
   --disable-x11-shared || exit 1
 
 make $NUMJOBS || make || exit 1
diff -ur slackware64-current.2/source/l/speexdsp/speexdsp.SlackBuild slackware64-current.3/source/l/speexdsp/speexdsp.SlackBuild
--- slackware64-current.2/source/l/speexdsp/speexdsp.SlackBuild	2021-02-13 06:32:03.250945004 +0100
+++ slackware64-current.3/source/l/speexdsp/speexdsp.SlackBuild	2021-09-18 13:42:55.767040991 +0200
@@ -88,7 +88,7 @@
   --mandir=/usr/man \
   --docdir=/usr/doc/$PKGNAM-$VERSION \
   --enable-static=no \
-  --build=$ARCH-slackware-linux || exit 1
+  $EXTRACONF --build=$ARCH-slackware-linux || exit 1
 
 make $NUMJOBS || make || exit 1
 make install DESTDIR=$PKG || exit 1
diff -ur slackware64-current.2/source/l/v4l-utils/v4l-utils.SlackBuild slackware64-current.3/source/l/v4l-utils/v4l-utils.SlackBuild
--- slackware64-current.2/source/l/v4l-utils/v4l-utils.SlackBuild	2010-08-09 23:14:43.000000000 +0200
+++ slackware64-current.3/source/l/v4l-utils/v4l-utils.SlackBuild	2017-12-08 14:49:40.096583760 +0100
@@ -71,6 +71,15 @@
 tar xvf $CWD/$PKGNAM-$VERSION.tar.?z || exit 1
 cd $PKGNAM-$VERSION || exit 1
 
+# Disable _TIME_BITS=64 (not useful and in conflict on v4l2convert.c):
+zcat $CWD/disable_time64.diff.gz | patch -p1 --verbose || exit 1
+# v4l2-tracer did not link with _TIME_BITS=64, disabling it for the whole package:
+SLKCFLAGS="$SLKCFLAGS -D_DONOTFORCE_TIME_BITS"
+#if [ "$LIBDIRSUFFIX" = "" -a `gcc -dM -E - < /dev/null | grep -c LP64.*1` -eq 0  ]; then
+#  # You have to disable tracer if you want _TIME_BITS=64
+#  TRACER="--disable-v4l2-tracer"
+#fi
+
 # Make sure ownerships and permissions are sane:
 chown -R root:root .
 find . \
diff -ur slackware64-current.2/source/l/zlib/zlib.SlackBuild slackware64-current.3/source/l/zlib/zlib.SlackBuild
--- slackware64-current.2/source/l/zlib/zlib.SlackBuild	2021-02-13 06:32:03.250945004 +0100
+++ slackware64-current.3/source/l/zlib/zlib.SlackBuild	2021-09-18 13:42:55.767040991 +0200
@@ -81,7 +81,7 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
-CFLAGS="$SLKCFLAGS" \
+CFLAGS="$SLKCFLAGS -D_DONOTFORCE_TIME_BITS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
diff -ur slackware64-current.2/source/n/curl/curl.SlackBuild slackware64-current.3/source/n/curl/curl.SlackBuild
--- slackware64-current.2/source/n/curl/curl.SlackBuild	2021-05-29 19:23:09.213002935 +0200
+++ slackware64-current.3/source/n/curl/curl.SlackBuild	2021-09-18 13:42:55.837044524 +0200
@@ -52,6 +52,8 @@
 # Set this variable to "--without-ssl" to build a no-SSL version:
 SSLOPT=${SSLOPT:-"--with-openssl"}
 
+SLKLDFLAGS=""
+
 if [ "$ARCH" = "i586" ]; then
   SLKCFLAGS="-O2 -march=i586 -mtune=i686"
   LIBDIRSUFFIX=""
@@ -80,7 +86,11 @@
   \( -perm 666 -o -perm 664 -o -perm 600 -o -perm 444 -o -perm 440 -o -perm 400 \) \
   -exec chmod 644 {} \+
 
+# Adding missing #include <sched.h>
+zcat $CWD/sched_yield-missing_include.diff.gz | patch -p1 --verbose || exit 1
+
 CFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --libdir=/usr/lib${LIBDIRSUFFIX} \
diff -ur slackware64-current.2/source/n/dhcp/dhcp.SlackBuild slackware64-current.3/source/n/dhcp/dhcp.SlackBuild
--- slackware64-current.2/source/n/dhcp/dhcp.SlackBuild	2021-05-29 19:23:09.213002935 +0200
+++ slackware64-current.3/source/n/dhcp/dhcp.SlackBuild	2021-09-18 13:42:55.837044524 +0200
@@ -85,6 +85,9 @@
 # Add PATH setting to /sbin/dhclient-script
 zcat $CWD/dhclient-script.PATH.diff.gz | patch -p1 || exit 1
 
+# Add build-aux scripts for riscv64:
+(cd bind; zcat $CWD/bind-build-aux-Makefile.patch.gz | patch --verbose)
+
 # Fix paths in manual pages
 sed -i \
     -e "s,ETCDIR,/etc,g" \
@@ -95,6 +99,7 @@
     doc/*/*.{5,8}
 
 CFLAGS="$SLKCFLAGS" \
+LDFLAGS="$SLKLDFLAGS" \
 ./configure \
   --prefix=/usr \
   --sysconfdir=/etc \
diff -ur slackware64-current.2/source/n/dhcpcd/dhcpcd.SlackBuild slackware64-current.3/source/n/dhcpcd/dhcpcd.SlackBuild
--- slackware64-current.2/source/n/dhcpcd/dhcpcd.SlackBuild	2021-05-29 19:23:09.213002935 +0200
+++ slackware64-current.3/source/n/dhcpcd/dhcpcd.SlackBuild	2021-09-18 13:42:55.837044524 +0200
@@ -75,6 +75,10 @@
 rm -rf dhcpcd-$VERSION
 tar xvf $CWD/dhcpcd-$VERSION.tar.?z || exit 1
 cd dhcpcd-$VERSION
+
+# Add loongarch64 AUDIT support:
+patch -p1 --verbose < $CWD/patches/loongarch_audit_support.patch || exit 1
+
 chown -R root:root .
 find . \
  \( -perm 777 -o -perm 775 -o -perm 711 -o -perm 555 -o -perm 511 \) \
